/**
** V1
*/
// // Nombre de colonnes
// $grid-columns: 12;

// // Espace entre les colonnes
// $gutter-width: 30px;

// // Points de rupture
// $breakpoints: (
//   xs: 0,
//   sm: 576px,
//   md: 768px,
//   lg: 992px,
//   xl: 1200px,
// );

// // Mixin pour créer une colonne
// @mixin make-col($size) {
//   flex: 0 0 auto;
//   width: calc($size / $grid-columns * 100%);
//   max-width: calc($size / $grid-columns * 100%);
//   // margin-right: $gutter-width;

//   &:last-child {
//     margin-right: 0;
//   }
// }

// // Mixin pour créer une rangée
// .row{
//     display: flex;
//     flex-wrap: wrap;
//     //   margin-left: -calc($gutter-width / 2);
//     //   margin-right: -calc($gutter-width / 2);
// }

// // Mixin pour créer des points de rupture
// @mixin breakpoint($point) {
//   @if map-has-key($breakpoints, $point) {
//     @media (min-width: map-get($breakpoints, $point)) {
//       @content;
//     }
//   } @else {
//     @error "Point de rupture invalide : #{$point}.";
//   }
// }

// // Classe pour créer une colonne de base
// .col {
//   margin: 0 calc($gutter-width / 2);
// }

// // Classes pour les colonnes
// @for $i from 1 through $grid-columns {
//     // Ajout des points de rupture pour chaque taille de colonne
//     @include breakpoint(xs) {
//       .col-xs-#{$i} {
//         @include make-col($i);
//       }
//     }

//     @include breakpoint(sm) {
//       .col-sm-#{$i} {
//         @include make-col($i);
//       }
//     }

//     @include breakpoint(md) {
//       .col-md-#{$i} {
//         @include make-col($i);
//       }
//     }

//     @include breakpoint(lg) {
//       .col-lg-#{$i} {
//         @include make-col($i);
//       }
//     }

//     @include breakpoint(xl) {
//       .col-xl-#{$i} {
//         @include make-col($i);
//       }
//     }
// }


/**
** V2
*/
// // Nombre de colonnes
// $grid-columns: 12;

// // Espace entre les colonnes
// $gutter-width: 30px;

// // Points de rupture
// $breakpoints: (
//   xs: 0,
//   sm: 576px,
//   md: 768px,
//   lg: 992px,
//   xl: 1200px,
// );

// // Mixin pour créer une colonne
// @mixin make-col($size) {
//   flex: 0 0 auto;
//   width: calc((#{$size} / #{$grid-columns} * 100%) - #{$gutter-width});
//   max-width: calc((#{$size} / #{$grid-columns} * 100%) - #{$gutter-width});
//   margin-right: $gutter-width;

//   &:last-child {
//     margin-right: 0;
//   }
// }

// // Mixin pour créer une rangée
// .row {
//   display: flex;
//   flex-wrap: wrap;
  
//   margin-left: -$gutter-width / 2;
//   margin-right: -$gutter-width / 2;
// }

// // Mixin pour créer des points de rupture
// @mixin breakpoint($point) {
//   @if map-has-key($breakpoints, $point) {
//     @media (min-width: map-get($breakpoints, $point)) {
//       @content;
//     }
//   } @else {
//     @error "Point de rupture invalide : #{$point}.";
//   }
// }

// // Classe pour créer une colonne de base
// .col {
//   margin: 0 calc($gutter-width / 2);
// }

// // Classes pour les colonnes
// @for $i from 1 through $grid-columns {
//   // Ajout des points de rupture pour chaque taille de colonne
//   @include breakpoint(xs) {
//     .col-xs-#{$i} {
//       @include make-col($i);
//     }
//   }

//   @include breakpoint(sm) {
//     .col-sm-#{$i} {
//       @include make-col($i);
//     }
//   }

//   @include breakpoint(md) {
//     .col-md-#{$i} {
//       @include make-col($i);
//     }
//   }

//   @include breakpoint(lg) {
//     .col-lg-#{$i} {
//       @include make-col($i);
//     }
//   }

//   @include breakpoint(xl) {
//     .col-xl-#{$i} {
//       @include make-col($i);
//     }
//   }
// }


/**
** V3
*/

// Nombre de colonnes
$grid-columns: 12;

// Espace entre les colonnes
$gutter-width: 30px;

// Points de rupture
$breakpoints: (
  xs: 0,
  sm: 576px,
  md: 768px,
  lg: 992px,
  xl: 1200px,
);

// Mixin pour créer une colonne
@mixin make-col($size) {
  flex: 0 0 auto;
  width: calc((#{$size} / #{$grid-columns} * 100%) - #{$gutter-width} + (#{$gutter-width} / #{$grid-columns}));
  $max-width: calc((#{$size} / #{$grid-columns} * 100%) - #{$gutter-width} + (#{$gutter-width} / #{$grid-columns}));
  padding-left: calc(#{$gutter-width} / 2);
  padding-right: calc(#{$gutter-width} / 2);
  box-sizing: border-box;
}

// Mixin pour créer une rangée
.row {
  display: flex;
  flex-wrap: wrap;
  margin-left: calc(-#{$gutter-width} / 2);
  margin-right: calc(-#{$gutter-width} / 2);
  justify-content: space-between;
}

// Mixin pour créer des points de rupture
@mixin breakpoint($point) {
  @if map-has-key($breakpoints, $point) {
    @media (min-width: map-get($breakpoints, $point)) {
      @content;
    }
  } @else {
    @error "Point de rupture invalide : #{$point}.";
  }
}

// Classe pour créer une colonne de base
.col {
  padding-left: calc(#{$gutter-width} / 2);
  padding-right: calc(#{$gutter-width} / 2);
}

// Classes pour les colonnes
@for $i from 1 through $grid-columns {
  // Ajout des points de rupture pour chaque taille de colonne
  @include breakpoint(xs) {
    .col-xs-#{$i} {
      @include make-col($i);
    }
  }

  @include breakpoint(sm) {
    .col-sm-#{$i} {
      @include make-col($i);
    }
  }

  @include breakpoint(md) {
    .col-md-#{$i} {
      @include make-col($i);
    }
  }

  @include breakpoint(lg) {
    .col-lg-#{$i} {
      @include make-col($i);
    }
  }

  @include breakpoint(xl) {
    .col-xl-#{$i} {
      @include make-col($i);
    }
  }
}